/**********************************************************************************
 * $URL: https://source.sakaiproject.org/svn/kernel/tags/kernel-1.3.3/kernel-private/src/main/java/org/sakaiproject/id/hbm/IdGenerator.java $
 * $Id: IdGenerator.java 51317 2008-08-24 04:38:02Z csev@umich.edu $
 ***********************************************************************************
 *
 * Copyright (c) 2004, 2005, 2006, 2008 Sakai Foundation
 *
 * Licensed under the Educational Community License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 **********************************************************************************/

package org.sakaiproject.id.hbm;

import java.io.Serializable;
import org.hibernate.HibernateException;
import org.hibernate.engine.SessionImplementor;
import org.hibernate.id.IdentifierGenerator;

import org.sakaiproject.id.cover.IdManager;

/**
 * Creates unique identifiers for hibernate based on the Sakai IdManager
 */
public class IdGenerator implements IdentifierGenerator
{
	public IdGenerator()
	{
	}

	public Serializable generate(SessionImplementor arg0, Object arg1) throws HibernateException
	{
		return IdManager.createUuid();
	}
}
